//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2015.06.09 at 11:11:31 AM CEST 
//


package net.ihe.gazelle.tempmodel.org.decor.art.model;

import java.util.ArrayList;
import gnu.trove.map.hash.THashMap;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAnyAttribute;
import javax.xml.bind.annotation.XmlAnyElement;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlSchemaType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;

import org.w3c.dom.Element;

import net.ihe.gazelle.tempmodel.org.decor.art.behavior.HasParent;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="desc" type="{}FreeFormMarkupWithLanguage" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;group ref="{}ValueSetCompilationSourceCodeSystem"/&gt;
 *         &lt;element name="publishingAuthority" type="{}AuthorityType" maxOccurs="0" minOccurs="0"/&gt;
 *         &lt;element name="endorsingAuthority" type="{}AuthorityType" maxOccurs="0" minOccurs="0"/&gt;
 *         &lt;element name="copyright" type="{}NonEmptyString" minOccurs="0"/&gt;
 *         &lt;element name="revisionHistory" type="{}ObjectHistory" maxOccurs="0" minOccurs="0"/&gt;
 *         &lt;element name="completeCodeSystem" type="{}CodeSystemReference" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;element name="conceptList" type="{}ValueSetConceptList" minOccurs="0"/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attGroup ref="{}ValueSetCompilationAttributes"/&gt;
 *       &lt;attGroup ref="{}VersionHandlingEffectiveDateOptional"/&gt;
 *       &lt;attribute name="id" type="{}Oid" /&gt;
 *       &lt;attribute name="ref" type="{}Oid" /&gt;
 *       &lt;attribute name="name" use="required" type="{}BasicId" /&gt;
 *       &lt;attribute ref="{}displayName use="required""/&gt;
 *       &lt;attribute name="statusCode" type="{}ItemStatusCodeLifeCycle" /&gt;
 *       &lt;attribute name="flexibility" type="{}StaticOrDynamicFlexibility" default="dynamic" /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "desc",
    "sourceCodeSystem",
    "copyright",
    "completeCodeSystem",
    "conceptList"
})
@XmlRootElement(name = "valueSet")
public class ValueSet implements HasParent {

    private List<FreeFormMarkupWithLanguage> desc;
    private List<ValueSet.SourceCodeSystem> sourceCodeSystem;
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String copyright;
    private List<CodeSystemReference> completeCodeSystem;
    private ValueSetConceptList conceptList;
    @XmlAttribute(name = "id")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String id;
    @XmlAttribute(name = "ref")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String ref;
    @XmlAttribute(name = "name", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String name;
    @XmlAttribute(name = "displayName", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String displayName;
    @XmlAttribute(name = "statusCode")
    private ItemStatusCodeLifeCycle statusCode;
    @XmlAttribute(name = "flexibility")
    private String flexibility;
    @XmlAttribute(name = "url")
    @XmlSchemaType(name = "anyURI")
    private String url;
    @XmlAttribute(name = "ident")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String ident;
    @XmlAttribute(name = "referencedFrom")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String referencedFrom;
    @XmlAttribute(name = "effectiveDate")
    private XMLGregorianCalendar effectiveDate;
    @XmlAttribute(name = "expirationDate")
    private XMLGregorianCalendar expirationDate;
    @XmlAttribute(name = "officialReleaseDate")
    private XMLGregorianCalendar officialReleaseDate;
    @XmlAttribute(name = "versionLabel")
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    private String versionLabel;
    
    @XmlTransient
   	private Terminology parentObject;

    @SuppressWarnings("unchecked")
	public Terminology getParentObject() {
   		return parentObject;
   	}

   	public void setParentObject(Terminology parentObject) {
   		this.parentObject = parentObject;
   	}
   	
   	void afterUnmarshal( javax.xml.bind.Unmarshaller u, Object parent ){
   		this.parentObject = (Terminology)parent;
   	}

    /**
     * Gets the value of the desc property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the desc property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDesc().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link FreeFormMarkupWithLanguage }
     * 
     * 
     */
    public List<FreeFormMarkupWithLanguage> getDesc() {
        if (desc == null) {
            desc = new ArrayList<>();
        }
        return this.desc;
    }

    /**
     * Gets the value of the sourceCodeSystem property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the sourceCodeSystem property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getSourceCodeSystem().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ValueSet.SourceCodeSystem }
     * 
     * 
     */
    public List<ValueSet.SourceCodeSystem> getSourceCodeSystem() {
        if (sourceCodeSystem == null) {
            sourceCodeSystem = new ArrayList<>();
        }
        return this.sourceCodeSystem;
    }

    /**
     * Gets the value of the copyright property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getCopyright() {
        return copyright;
    }

    /**
     * Sets the value of the copyright property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setCopyright(String value) {
        this.copyright = value;
    }

    /**
     * Gets the value of the completeCodeSystem property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the completeCodeSystem property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getCompleteCodeSystem().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CodeSystemReference }
     * 
     * 
     */
    public List<CodeSystemReference> getCompleteCodeSystem() {
        if (completeCodeSystem == null) {
            completeCodeSystem = new ArrayList<>();
        }
        return this.completeCodeSystem;
    }

    /**
     * Gets the value of the conceptList property.
     * 
     * @return
     *     possible object is
     *     {@link ValueSetConceptList }
     *     
     */
    public ValueSetConceptList getConceptList() {
        return conceptList;
    }

    /**
     * Sets the value of the conceptList property.
     * 
     * @param value
     *     allowed object is
     *     {@link ValueSetConceptList }
     *     
     */
    public void setConceptList(ValueSetConceptList value) {
        this.conceptList = value;
    }

    /**
     * Gets the value of the id property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getId() {
        return id;
    }

    /**
     * Sets the value of the id property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setId(String value) {
        this.id = value;
    }

    /**
     * Gets the value of the ref property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getRef() {
        return ref;
    }

    /**
     * Sets the value of the ref property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setRef(String value) {
        this.ref = value;
    }

    /**
     * Gets the value of the name property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getName() {
        return name;
    }

    /**
     * Sets the value of the name property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setName(String value) {
        this.name = value;
    }

    /**
     * Gets the value of the displayName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getDisplayName() {
        return displayName;
    }

    /**
     * Sets the value of the displayName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setDisplayName(String value) {
        this.displayName = value;
    }

    /**
     * Gets the value of the statusCode property.
     * 
     * @return
     *     possible object is
     *     {@link ItemStatusCodeLifeCycle }
     *     
     */
    public ItemStatusCodeLifeCycle getStatusCode() {
        return statusCode;
    }

    /**
     * Sets the value of the statusCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link ItemStatusCodeLifeCycle }
     *     
     */
    public void setStatusCode(ItemStatusCodeLifeCycle value) {
        this.statusCode = value;
    }

    /**
     * Gets the value of the flexibility property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFlexibility() {
        if (flexibility == null) {
            return "dynamic";
        } else {
            return flexibility;
        }
    }

    /**
     * Sets the value of the flexibility property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFlexibility(String value) {
        this.flexibility = value;
    }

    /**
     * Gets the value of the url property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getUrl() {
        return url;
    }

    /**
     * Sets the value of the url property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setUrl(String value) {
        this.url = value;
    }

    /**
     * Gets the value of the ident property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Sets the value of the ident property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIdent(String value) {
        this.ident = value;
    }

    /**
     * Gets the value of the referencedFrom property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getReferencedFrom() {
        return referencedFrom;
    }

    /**
     * Sets the value of the referencedFrom property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setReferencedFrom(String value) {
        this.referencedFrom = value;
    }

    /**
     * Gets the value of the effectiveDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getEffectiveDate() {
        return effectiveDate;
    }

    /**
     * Sets the value of the effectiveDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setEffectiveDate(XMLGregorianCalendar value) {
        this.effectiveDate = value;
    }

    /**
     * Gets the value of the expirationDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getExpirationDate() {
        return expirationDate;
    }

    /**
     * Sets the value of the expirationDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setExpirationDate(XMLGregorianCalendar value) {
        this.expirationDate = value;
    }

    /**
     * Gets the value of the officialReleaseDate property.
     * 
     * @return
     *     possible object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public XMLGregorianCalendar getOfficialReleaseDate() {
        return officialReleaseDate;
    }

    /**
     * Sets the value of the officialReleaseDate property.
     * 
     * @param value
     *     allowed object is
     *     {@link XMLGregorianCalendar }
     *     
     */
    public void setOfficialReleaseDate(XMLGregorianCalendar value) {
        this.officialReleaseDate = value;
    }

    /**
     * Gets the value of the versionLabel property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getVersionLabel() {
        return versionLabel;
    }

    /**
     * Sets the value of the versionLabel property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setVersionLabel(String value) {
        this.versionLabel = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;any processContents='skip' maxOccurs="unbounded" minOccurs="0"/&gt;
     *       &lt;/sequence&gt;
     *       &lt;anyAttribute processContents='skip'/&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "any"
    })
    public static class SourceCodeSystem {

        @XmlAnyElement
        private List<Element> any;
        @XmlAnyAttribute
        private Map<QName, String> otherAttributes = new THashMap<>();

        /**
         * Gets the value of the any property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the any property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getAny().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link Element }
         * 
         * 
         */
        public List<Element> getAny() {
            if (any == null) {
                any = new ArrayList<>();
            }
            return this.any;
        }

        /**
         * Gets a map that contains attributes that aren't bound to any typed property on this class.
         * 
         * <p>
         * the map is keyed by the name of the attribute and 
         * the value is the string value of the attribute.
         * 
         * the map returned by this method is live, and you can add new attribute
         * by updating the map directly. Because of this design, there's no setter.
         * 
         * 
         * @return
         *     always non-null
         */
        public Map<QName, String> getOtherAttributes() {
            return otherAttributes;
        }

    }

}
